CREATE TABLE socio
	( codsoc NUMBER constraint cp_socio PRIMARY KEY deferrable,
	  nombre varchar(40) NOT NULL,  	  dir varchar(60),
	  tel varchar(15),		  totalpres number default 0 not null deferrable );
CREATE TABLE libro 
	(codlib number constraint cp_libro PRIMARY KEY deferrable,
	 titulo varchar(50) NOT NULL, 	autores varchar(60) NOT NULL,
	tematica varchar(20), 
	constraint r1 CHECK (tematica IN ('Fisica','Optica','Mecanica','Electricidad')) );
CREATE TABLE prestamo 
	(codlib number, codsoc number NOT NULL, fechapres date, fechadev date,
	  constraint cp_prestamo PRIMARY KEY(codlib, fechapres) deferrable, 
        constraint ca_pre_libro FOREIGN KEY (codlib) REFERENCES libro  deferrable,
        constraint ca_pre_socio FOREIGN KEY (codsoc) REFERENCES socio  deferrable,
       constraint R2 CHECK (fechapres <= fechadev)  deferrable    );



CREATE TRIGGER T1
AFTER INSERT ON Prestamo
FOR EACH ROW
BEGIN
	IF :new.fechadev IS NULL THEN
		UPDATE socio SET totalpres = totalpres +1
				  WHERE codsoc = :new.codsoc;
	END IF;
END;

CREATE TRIGGER T2
AFTER UPDATE OF fechadev ON Prestamo
FOR EACH ROW
BEGIN
	IF :new.fechadev IS NULL AND :old.fechadev IS NOT NULL THEN
		UPDATE socio SET totalpres = totalpres +1 WHERE codsoc = :new.codsoc;
	ELSE IF :new.fechadev IS NOT NULL AND :old.fechadev IS NULL THEN
		UPDATE socio SET totalpres = totalpres -1  WHERE codsoc = :new.codsoc;
		END IF;
	END IF;
END;


CREATE TRIGGER T3
AFTER UPDATE OF codsoc ON Prestamo
FOR EACH ROW
BEGIN
	IF :new.fechadev IS NULL THEN
		UPDATE socio SET totalpres = totalpres +1 WHERE codsoc = :new.codsoc;
		UPDATE socio SET totalpres = totalpres -1  WHERE codsoc = :old.codsoc;
	END IF;
END;

CREATE TRIGGER T4
AFTER DELETE ON Prestamo
FOR EACH ROW
BEGIN
	IF :old.fechadev IS NULL THEN
		UPDATE socio SET totalpres = totalpres -1
				  WHERE codsoc = :old.codsoc;
	END IF;
END;

CREATE TRIGGER T5
AFTER INSERT ON Socio
FOR EACH ROW
BEGIN
   IF :new.totalpres <> 0 then
		 RAISE_APPLICATION_ERROR(-20000, Cuando se inserta un socio, 
					su nmero de prstamos ha de ser 0.);
   END IF;
END;


insert into socio
values (1, 'Soci 1', 'Adr1', 'tel1', 0);

insert into socio
values (2, 'Soci 2', 'Adr2', 'tel2', 0);

insert into socio
values (3, 'Soci 3', 'Adr3', 'tel3', 0);

insert into libro
values (1, 'Llibre 1', 'autor 1', 'fsica');

insert into libro
values (2, 'Llibre 2', 'autor 2', 'mecnica');

insert into libro
values (3, 'Llibre 3',  'autor 3', 'electricidad');

insert into libro
values (4, 'Llibre 4',  'autor 4', 'ptica');

insert into prestamo
values (1, 4, '5/11/99', '9/11/99');

insert into prestamo
values (3, 4, '11/11/99', '12/11/99');

